// This file was automatically generated by informer-gen

package v1

import (
	ark_v1 "github.com/heptio/ark/pkg/apis/ark/v1"
	clientset "github.com/heptio/ark/pkg/generated/clientset"
	internalinterfaces "github.com/heptio/ark/pkg/generated/informers/externalversions/internalinterfaces"
	v1 "github.com/heptio/ark/pkg/generated/listers/ark/v1"
	meta_v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
	time "time"
)

// BackupInformer provides access to a shared informer and lister for
// Backups.
type BackupInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.BackupLister
}

type backupInformer struct {
	factory internalinterfaces.SharedInformerFactory
}

func newBackupInformer(client clientset.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	sharedIndexInformer := cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options meta_v1.ListOptions) (runtime.Object, error) {
				return client.ArkV1().Backups(meta_v1.NamespaceAll).List(options)
			},
			WatchFunc: func(options meta_v1.ListOptions) (watch.Interface, error) {
				return client.ArkV1().Backups(meta_v1.NamespaceAll).Watch(options)
			},
		},
		&ark_v1.Backup{},
		resyncPeriod,
		cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc},
	)

	return sharedIndexInformer
}

func (f *backupInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&ark_v1.Backup{}, newBackupInformer)
}

func (f *backupInformer) Lister() v1.BackupLister {
	return v1.NewBackupLister(f.Informer().GetIndexer())
}
